*  FILE: ADVENT01/ASM
*
* VERB PROCESSING ROUTINES
*

*******************************
*
* "LOOK" VERB HANDLER
*
*******************************

VLOOK EQU *
 JSR INDARK
 LBEQ REPLY
 LDA NOUNNO
 LBNE LOOKOB
 JSR CLS
 JSR DRAWSC
 LDB ROOM
A@ LDX #DESCTB DESCRIPTIONS
B@ DECB FIND DESC FOR THIS ROOM
 BEQ D@
C@ TST ,X+
 BNE C@
 BRA B@
D@ LDA ,X 1ST CHAR OF DESC
 CMPA #$FF IS IT POINTER?
 BNE E@ NO:DISPLAY IT
 LDB 1,X GET NEW ROOM #
 BRA A@ DISPLAY NEW ROOM
E@ JSR DISPLY DISPLAY ROOM DESC
 LDA ROOM DISPLAY ALL DIRECTIONS
 DECA
 LDB #RMSIZE
 MUL
 ADDD #ROOMTB
 TFR D,Y
 TFR D,X SEE IF ANY EXITS
 LDB #6
P@ TST ,X+
 BNE Q@
 DECB
 BNE P@
 LEAY 6,Y
 BRA R@
Q@ LDX #MSG1 DIRECTION MSG
 JSR DISPLY
 LDX #DIRECT
 LDB #6
F@ LDA ,Y+
 BEQ G@ DIRECTION NOT AVAIL
 BMI G@ DIRECTION UNSEEN
 JSR DISPLY
G@ TST ,X+
 BNE G@
 DECB
 BNE F@
 JSR PERIOD
R@ TFR Y,X SEE IF ANY OBJ IN ROOM
 LDB #RMOBJ
 CLRA
H@ TST ,X+
 BEQ I@ NOT AN OBJ
 BMI I@ UNSEEN OBJ
 INCA
I@ DECB
 BNE H@
 TSTA ANY VISIBLE OBJ?
 BEQ O@ NO:ALL DONE
 LDX #MSG2 OBJECTS SEEN MSG
 JSR DISPLY
 LDB #RMOBJ
M@ LDX #OBJTAB OBJECT DESC TBL
 LDA ,Y+ ROOMTB OBJ PNTR
 BEQ N@ NO OBJECT
 BMI N@ UNSEEN OBJECT
J@ CMPA ,X+ GET OBJ DESC
 BEQ L@
K@ TST ,X+
 BNE K@
 BRA J@
L@ LDA ,X
 CMPA #$FF IS IT POINTER?
 BNE T@
 LDA 1,X
 LDX #OBJTAB
 BRA J@
T@ JSR DISPLY OBJECT DESC
 LDX #COMMA
 JSR DISPLY
N@ DECB
 BNE M@ LOOP THRU ALL OBJ
 JSR PERIOD
O@ JMP REPLY

*******************************
*
* GENERAL LOOK AT OBJECT RTN
*
*******************************

LOOKOB EQU *
 LDA NOUNNO
 CLRB
 JSR HAVOBJ
 BNE B@
 LDA NOUNNO
 JSR CKOBJ
 BEQ NOSEE
 INCB
B@ INCB
 LDX #OBJMSG
C@ TST ,X
 LBEQ DMSG12
 CMPA ,X
 BEQ D@
 LEAX 3,X
 BRA C@
D@ LDA B,X
 JMP DMSGXX

*******************************
*
*  GENERAL DON'T SEE ROUTINE
*
*******************************

NOSEE EQU *
 LDA NOUNNO
 LDX #THEMTB
A@ TST ,X
 LBEQ DMSG7
 CMPA ,X+
 BNE A@
 JMP DMSG45

*******************************
*
*  GENERAL DON'T HAVE ROUTINE
*
*******************************

NOHAVE EQU *
 LDA NOUNNO
 LDX #THEMTB
A@ TST ,X
 LBEQ DMSG10
 CMPA ,X+
 BNE A@
 JMP DMSG71

*******************************
*
* GENERAL ALREADY HAVE ROUTINE
*
*******************************

ALRHAV EQU *
 LDA NOUNNO
 LDX #THEMTB
A@ TST ,X
 LBEQ DMSG8
 CMPA ,X+
 BNE A@
 JMP DMSG72

*******************************
*
* GO VERB PROCESSOR
*
*******************************

VNORTH LDA #1
 FCB $8C
VSOUTH LDA #2
 FCB $8C
VEAST LDA #3
 FCB $8C
VWEST LDA #4
 FCB $8C
VUP LDA #5
 FCB $8C
VDOWN LDA #6
 STA NOUNNO
VGO LDA NOUNNO VERIFY DIRECTION
 BEQ C@
 BMI C@
D@ CMPA #6
 BHI C@
 LDB ROOM CALC ADDR IN ROOMTB
 DECB
 LDA #RMSIZE
 MUL
 ADDD #ROOMTB
 TFR D,X
 LDA NOUNNO GET NEXT ROOM #
 DECA
 LDA A,X
 BEQ B@ NO ROOM THAT DIRECTION
 BMI B@ UNSEEN ROOM
EXITRM EQU *
 TFR A,B
 LDX #EXITTB SPECIAL EXIT RTNS
E@ LDA ,X+
 BEQ G@
 CMPA ROOM
 BEQ F@
 LEAX 2,X
 BRA E@
F@ JSR [,X]
G@ INC NEWRM
 STB ROOM SET NEW ROOM
 CLR NOUNNO
A@ JMP VLOOK
B@ LDX #MSG3 NO WAY TO GO
 JSR DISPLY
 JMP REPLY
C@ JMP BADINP

*******************************
*
* INVENTORY VERB PROCESSOR
*
*******************************

VINVE EQU *
 LDX #GSCRN
 STX SCRTOP
 LDX #MSG5 I AM CARRYING MSG
 JSR DISPLY
 LDX #OBJECT OBJ CARRYING TBL
 LDD #MAXOBJ SEE IF CARRYING
A@ TST ,X+ .. ANYTHING
 BEQ B@
 INCA
B@ DECB
 BNE A@
 TSTA CARRYING ANYTHING?
 BEQ I@ NO
 LDY #OBJECT
 LDB #MAXOBJ
C@ LDA ,Y+ DISPLAY OBJECTS
 BEQ G@
 LDX #OBJTAB
D@ CMPA ,X+
 BEQ F@
E@ TST ,X+
 BNE E@
 BRA D@
F@ LDA ,X
 CMPA #$FF IS IT POINTER?
 BNE J@
 LDA 1,X
 LDX #OBJTAB
 BRA D@
J@ LDA #13
 JSR CHROUT
 JSR DISPLY
 LDX #COMMA
 JSR DISPLY
G@ DECB
 BNE C@
 JSR PERIOD
H@ JMP REPLY
I@ LDX #MSG6 CARRYING NOTHING
 JSR DISPLY
 BRA H@

*******************************
*
* PUT VERB PROCESSOR
*
*******************************

VPUT EQU *
 LDA NOUNNO GOOD OBJ NUMBER?
 LBEQ BADINP NO
 CMPA #128 IS IT "PUT ALL"?
 BEQ E@ YES
 JSR HAVOBJ
 LBEQ NOHAVE
 JSR PUTOBJ
 JSR CKDRAW
 CLRB
 JSR REPOBJ
D@ JMP REPLY
E@ LDX #OBJECT HANDLE "PUT ALL"
 LDB #MAXOBJ
F@ LDA ,X+
 BEQ G@
 JSR CHKPA CHK ADV RESTRICT
 BEQ G@
 CLR -1,X
 DEC OBJCNT
 JSR PUTOBJ
 JSR CKDRAW
G@ DECB
 BNE F@
 BRA D@

 IFEQ R.PNRM
*******************************
*== PUTNRM ==
* PUT AN OBJECT IN A ROOM WITH
* NO POINT OR MOVED LOCATION
* CHECKING
*
* INPUT:  A = OBJECT #
*
*******************************

PUTNRM EQU *
 PSHS D,X
 PSHS A
 LDA ROOM
 LDB #RMSIZE
 DECA
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
 PULS A
A@ TST ,X+
 BEQ B@
 DECB
 BNE A@
 BRA C@
B@ STA -1,X
C@ PULS D,X,PC
 ENDC

*******************************
*== PUTOBJ ==
* PUT OBJECT IN CURRENT ROOM
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: NONE
*
*******************************

VEC17 EQU *
 PSHS D,X
 LDB ROOM
 PSHS B
 PSHS A
 LDX #PUTTAB
A@ TST ,X
 BEQ C@
 CMPB ,X
 BEQ B@
 LEAX 2,X
 BRA A@
B@ LDB 1,X
C@ LDA #RMSIZE
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
D@ TST ,X+
 BEQ F@
 DECB
 BNE D@
E@ PULS B
 STB ROOM
 PULS D,X,PC
F@ STA -1,X
 LDB ROOM
 CMPB #1 ROOM TO DROP TREASURE
 BNE E@
 LDX #PNTTAB
G@ TST ,X
 BEQ E@
 CMPA ,X++
 BNE G@
 LDA -1,X
 ADDA POINTS
 STA POINTS
 CLR -1,X
 BRA E@

 IFEQ R.RVIS
*******************************
*== RMVIS ==
* MAKE ROOM VISIBLE
*
* INPUT:  A = INVISIBLE ROOM #
*
*******************************

VEC18 EQU *
 PSHS B,X
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB
 TFR D,X
 PULS A
 LDB #6
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B,X,PC
B@ ANDA #$7F
 STA -1,X
 PULS B,X,PC
 ENDC

*******************************
*== CKDRAW ==
* CHECK IF SCREEN NEEDS TO BE
* RE-DRAWN
*
*******************************

VEC19 EQU *
 PSHS D,X
 TFR A,B
 JSR INDARK
 BEQ D@
 TFR B,A
 LDX #MOVOBJ
A@ TST ,X
 BEQ D@
 CMPA ,X
 BEQ C@
B@ LEAX 3,X
 BRA A@
C@ LDB 1,X
 CMPB ROOM
 BNE B@
 LDD ROWCOL
 PSHS D
 JSR DRAWSC
 PULS D
 CMPD #$0B00
 BLO D@
 STD ROWCOL
D@ PULS D,X,PC

*******************************
*== DRAWSC ==
* RE-DRAW GRAPHIC SCREEN
*
*******************************

VEC20 EQU *
 PSHS D,X,Y,U
 LDD #GSCRN
 STD SCRTOP
 LDB ROOM
 DECB
 LDA #NOVLY+1
 MUL
 ADDD #SCRIND
 TFR D,X
 LDA ,X+
 BEQ A@
 DECA
 LSLA
 TFR X,Y
 LDX #SCRTAB
 LDU A,X
 JSR SHOSC2
 TFR Y,X
 JSR SHOOBJ
 LDD #$0B00
 STD ROWCOL
 LDD #GSCRN+288*10
 STD SCRTOP
A@ PULS D,X,Y,U,PC

*******************************
* == XFROBJ ==
* TRANSFER MOVABLE OBJECTS
* FROM ONE ROOM TO ANOTHER.
*
* INPUT:  A= FROM ROOM
*         B= TO ROOM
*
*******************************

XFROBJ EQU *
 PSHS D,X,Y,U
 TFR D,U
 LDA ROOM
 PSHS A
 LDA #RMSIZE
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,Y
 TFR U,D
 LDB #RMSIZE
 DECA
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
A@ LDA ,Y+
 CMPA #64
 BHI B@
 CLR -1,Y
B@ DECB
 BNE A@
 TFR U,D
 STB ROOM
 LDB #RMOBJ
C@ LDA ,X+
 BEQ D@
 CMPA #64
 BHI D@
 JSR PUTOBJ
D@ DECB
 BNE C@
 PULS A
 STA ROOM
 TFR U,D
 PULS D,X,Y,U,PC

*******************************
* == CLRRM ==
* REMOVE ALL OBJECTS FROM A
* ROOM
*
* INPUT:  A= ROOM TO CLEAR
*
*******************************

CLRRM EQU *
 PSHS D,X
 LDB #RMSIZE
 DECA
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
A@ CLR ,X+
 DECB
 BNE A@
 PULS D,X,PC

*******************************
* == CLROBJ ==
* REMOVE ALL MOVABLE OBJECTS
* FROM A ROOM
*
* INPUT:  A= ROOM TO CLEAR
*
*******************************

CLROBJ EQU *
 PSHS D,X
 LDB #RMSIZE
 DECA
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
A@ LDA ,X+
 CMPA #64
 BHI B@
 CLR -1,X
B@ DECB
 BNE A@
 PULS D,X,PC

******************************
*
* GET VERB PROCESSOR
*
*******************************

VGET EQU *
 JSR GETSHA CHK GET IN SHACK
 LDA NOUNNO VALID NOUN?
 LBEQ BADINP NO
 CMPA #128 IS IT "GET ALL"?
 BEQ I@ YES
 CMPA #64 IMMOVABLE OBJ?
 LBHI DMSG15 YES
 JSR HAVOBJ
 LBNE ALRHAV ALREADY HAS IT
 LDA OBJCNT CAN HE CARRY MORE?
 CMPA #MAXOBJ
 BHS E@ NO
 LDA NOUNNO SEE IF IN ROOM
 JSR GETOBJ
 BNE F@ FOUND OBJ
 JMP NOSEE
E@ JMP DMSG9
VGET01 EQU *
F@ JSR GIVOBJ
 JSR CKDRAW
 INC OBJCNT
H@ JMP REPLY
I@ LDB ROOM HANDLE "GET ALL"
 DECB
 LDA #RMSIZE
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 LDB #RMOBJ
J@ TST ,X+
 BMI L@ UNSEEN OBJ
 BEQ L@ NO OBJ
 LDA OBJCNT
 CMPA #MAXOBJ
 BHS E@ CAN'T CARRY MORE
 LDA -1,X
 CMPA #64 IS IT PERM OBJ?
 BHI L@ YES
 JSR CHKGA CHK ADV RESTRICT
 BEQ L@
 CLR -1,X
 LDY #OBJECT
K@ TST ,Y+
 BNE K@
 STA -1,Y
 JSR CKDRAW
 INC OBJCNT
L@ DECB
 BNE J@
 BRA H@

*******************************
*
* SCORE VERB PROCESSOR
*
*******************************

VSCORE EQU *
 LDB POINTS
 CLRA
 TFR D,X
 LDY #MSG24B
 JSR ASCLNO
 BSR SUPRES
 LDX SCORE
 LEAX -1,X
 STX SCORE
 LDY #MSG24A
 JSR ASCLNO
 BSR SUPRES
 JMP DMSG24

*******************************
*
* ZERO SUPPRESS ASCII NUMBER
*
*******************************

SUPRES EQU *
 PSHS D,Y
 LDB #4
A@ LDA #'0
 CMPA ,Y+
 BNE B@
 LDA #$20
 STA -1,Y
 DECB
 BNE A@
B@ PULS D,X,PC

******************************
*== GETOBJ ==
* SEE IF OBJECT IS IN ROOM AND
* GET IT IF FOUND
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: A = 0 -> NOT FOUND
*         A > 0 FOUND & REMOVED
*
*******************************

VEC16 EQU *
 PSHS B,X SAVE REGS
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 CLRA
 BRA C@
B@ CLR -1,X
C@ TSTA
 PULS B,X,PC

*******************************
*== HAVOBJ ==
* CHK IF PLAYER HAS AN OBJECT
*
* INPUT:  A = OBJECT NUMBER
* OUTPUT: A = 0 -> HE DOESN'T
*           > 0 -> HE HAS IT
*
*******************************

VEC15 EQU *
 PSHS B,X
 LDX #OBJECT
 LDB #MAXOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 CLRA
B@ TSTA
 PULS B,X,PC

*******************************
*== REPOBJ ==
* REPLACE OBJECT PLAYER HAS
*
* INPUT:  A = OBJ TO FIND
*         B = REPLACEMENT
* OUTPUT: NONE
*
*******************************

VEC14 EQU *
 PSHS D,X
 PSHS B
 LDX #OBJECT
 LDB #MAXOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B
 BRA C@
B@ PULS B
 STB -1,X
 TSTB
 BNE C@
 DEC OBJCNT
C@ PULS D,X,PC

*******************************
*== GIVOBJ ==
* GIVE PLAYER AN OBJECT
*
* INPUT:  A = OBJECT TO GIVE
* OUTPUT: NONE
*
*******************************

VEC13 EQU *
 PSHS B,X
 LDX #OBJECT
 LDB #MAXOBJ
A@ TST ,X+
 BEQ B@
 DECB
 BNE A@
 BRA C@
B@ STA -1,X
C@ PULS B,X,PC

*******************************
*== LOCOBJ ==
* LOCATE OBJECT EITHER IN
* PLAYERS HAND OR CURRENT ROOM
*
*******************************

VEC21 EQU *
 PSHS D
 TFR A,B
 JSR HAVOBJ
 BNE A@
 TFR B,A
 JSR CKOBJ
A@ PULS D,PC

*******************************
*
* SPECIAL EXIT ROOM ROUTINES
*
*******************************

*******************************
*== BADINP ==
* I JUST DON'T UNDERSTAND RTN
*
*******************************

VEC06 EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #MSG4 DON'T UNDERSTAND
 JSR DISPLY
 LDX #KEYBUF
 JSR DISPLY
 LDA #'"
 JSR CHROUT
 BRA VEC07A

*******************************
*== REPLY ==
* ADVENTURE MAINLINE ROUTINE
* GET KEYBOARD INPUT, EXAMINE
* AND EXECUTE IT.
*
*******************************

VEC07 EQU *
 LDS #GSCRN
 LDA POINTS
 CMPA #MAXPNT
 LBEQ FINI
 TST NEWRM
 BEQ D@
 CLR FLIPSW
 CLR FLIPCT
 CLR FLIPCT+1
 CLR RMMOVE
 LDX #ENTRTB
 CLR NEWRM
 BRA E@
D@ LDX #INRMTB
E@ LDA ,X+
 BEQ G@
 CMPA ROOM
 BEQ F@
 LEAX 2,X
 BRA E@
F@ JSR [,X]
G@ JSR ECHMOV
VEC07A LDX #MSG0 OK PROMPT
 JSR DISPLY
 JSR GETLIN GET KBD INPUT
 JSR SCNKEY EXAMINE INPUT
 INC RMMOVE
 LDD SCORE
 ADDD #1
 STD SCORE
 LDA NOUNNO CHK FOR CUSSING
 LDX #SPCRTN SPECIAL ROUTINE
A@ LDD ,X++
 BEQ C@
 CMPD VERBNO
 BNE B@
 JMP [,X]
B@ LEAX 2,X
 BRA A@
C@ LDB VERBNO CURRENT VERB
 LBEQ BADINP VERB NOT FOUND
 DECB
 LSLB
 LDX #RTNTAB VERB ROUTINES
 ABX
 JMP [,X]

*******************************
*== SCNKEY ==
* EXAMINE KEYBOARD INPUT AND
* EXTRACT THE VERB AND NOUN
*
* INPUT:  NONE
* OUTPUT: "VERB" CONTAINS VERB
*         "NOUN" CONTAINS NOUN
*
*******************************

VEC08 EQU *
 PSHS D,X,Y,U SAVE REGS
 LDX #VERB SPACE OUT VERB/NOUN
 TFR X,Y
 LDB #MAXWRD*2-1
 LDA #$20
 STA ,Y+
 JSR MOVE
 TFR X,U
 LDX #KEYBUF KEYBOARD BUFFER
 LDB #MAXWRD MAX VERB SIZE
A@ LDA ,X+ GET THE VERB
 BEQ E@ IF END OF TEXT
 CMPA #$20 IS IT SPACE?
 BEQ B@ YES:END OF VERB
 STA ,U+ PUT IN "VERB"
 DECB
 BNE A@ LOOP THRU VERB
F@ LDA ,X+ SCAN FOR A SPACE
 BEQ E@
 CMPA #$20
 BNE F@
B@ LDA ,X+ GET NEXT CHAR
 BEQ E@ IF END OF TEXT
 CMPA #$20 IS IT A SPACE
 BEQ B@ YES:LOOP TILL NON-BLANK
 DEX BACKUP 1 CHAR
 LDU #NOUN STORAGE FOR NOUN
 LDB #MAXWRD MAX LEN OF NOUN
D@ LDA ,X+ GET NEXT CHAR
 BEQ E@ IF END OF TEXT
 CMPA #$20 SPACE?
 BEQ E@ YES:ALL DONE
 STA ,U+ PUT IN "NOUN"
 DECB
 BNE D@
E@ CLR VERBNO CLEAR VERB/NOUN #
 CLR NOUNNO
 BSR CVTCAP
 LDX #VERBTB GET VERB NUMBER
 LDY #VERBNO
 LDU #VERB
 BSR SCNTBL
 LDX #NOUNTB GET NOUN NUMBER
 LDY #NOUNNO
 LDU #NOUN
 BSR SCNTBL
 PULS D,X,Y,U,PC

*******************************
*
* SCANS TABLE FOR VERB OR NOUN
* RETURNS ASSOCIATED VERB OR
* NOUN NUMBER.
*
* INPUT:  X = PNTR TO TABLE
*         Y = PNTR TO STORAGE
*             FOR VERB/NOUN #
*         U = PNTR TO KEYBOARD
*             INPUT TO SCAN FOR
* OUTPUT: CONTENTS OF "Y" ARE
*         ASSIGNED VERB/NOUN #
*
*******************************

SCNTBL EQU *
 PSHS D,X SAVE REGS
A@ PSHS U
 LDB #MAXWRD LEN OF COMPARE
B@ LDA ,X+ CHAR FROM TABLE
 BEQ C@ IF END OF TABLE
 CMPA ,U+ DO THEY MATCH?
 BNE D@ NO:NEXT TABLE ENTRY
 DECB COMPARE LEN
 BNE B@ LOOP TILL DONE
 LDA ,X GET VERB/NOUN #
 STA ,Y UPDATE USER AREA
C@ PULS U RESTORE "U"
 PULS D,X,PC
D@ INX BUMP TO NEXT ENTRY
 DECB
 BNE D@
 PULS U RESTORE VERB/NOUN
 BRA A@

*******************************
*
* CONVERTS INPUT VERB/NOUN TO
* ALL UPPER CASE LETTERS
*
* INPUT:  NONE
* OUTPUT: "VERB" & "NOUN" ARE
*         CONVERTED TO CAPS
*
*******************************

CVTCAP EQU *
 PSHS D,X SAVE REGS
 LDX #VERB
 LDB #MAXWRD*2
A@ LDA ,X+
 CMPA #'a LESS THAN L/C A?
 BLO B@ YES:SKIP
 CMPA #'z GREATER THEN L/C Z?
 BHI B@ YES:SKIP
 SUBA #32 MAKE UPPER CASE
 STA -1,X PUT IT BACK
B@ DECB
 BNE A@
 PULS D,X,PC

*******************************
*== PERIOD ==
* BACKUP & ADD PERIOD TO SCREEN
*
*******************************

VEC09 EQU *
 PSHS D,X,Y
A@ JSR CURPOS
 LDY #CHRCMA
 LDB #9
B@ LDA ,Y+
 COMA
 CMPA ,X
 BNE C@
 LEAX 32,X
 DECB
 BNE B@
 LDA #'.
 JSR CHROUT
 PULS D,X,Y,PC
C@ LDA #8
 JSR CHROUT
 BRA A@

*******************************
*== CHGOBJ ==
* REPLACE OBJECT IN CURRENT
* ROOM WITH ANOTHER OBJECT
*
* INPUT:  A = OBJ TO FIND
*         B = REPLACEMENT OBJ
* OUTPUT: NONE
*
*******************************

VEC10 EQU *
 PSHS X
 PSHS B
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B
 BRA C@
B@ PULS B
 STB -1,X
C@ PULS X,PC

*******************************
*== CKOBJ ==
* TEST IF AN OBJECT IS IN THE
* CURRENT ROOM
*
* INPUT:  A = OBJ TO FIND
* OUTPUT: A = 0 -> NOT FOUND
*
*******************************

VEC11 EQU *
 PSHS B,X
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 CLRA
B@ TSTA
 PULS B,X,PC

*******************************
*== MAKVIS ==
* MAKE AND OBJECT VISIBLE IN
* ROOM
*
* INPUT:  A = OBJECT TO FIND
* OUTPUT: NONE
*
*******************************

VEC12 EQU *
 PSHS B,X
 PSHS A
 LDA #RMSIZE
 LDB ROOM
 DECB
 MUL
 ADDD #ROOMTB+6
 TFR D,X
 PULS A
 LDB #RMOBJ
A@ CMPA ,X+
 BEQ B@
 DECB
 BNE A@
 PULS B,X,PC
B@ ANDA #$7F
 STA -1,X
 PULS B,X,PC

*******************************
*
* HELP VERB PROCESSOR
*
*******************************

VHELP EQU *
 LDX #GENHLP
 LDA RANDOM
 ANDA #3
 BEQ B@
A@ TST ,X+
 BNE A@
 DECA
 BNE A@
B@ JSR DISPLY
 JMP REPLY

*******************************
*
* DISPLAY MESSAGE ROUTINES
*
*******************************

DMSG7 LDA #7
 FCB $8C
DMSG8 LDA #8
 FCB $8C
DMSG9 LDA #9
 FCB $8C
DMSG10 LDA #10
 FCB $8C
DMSG11 LDA #11
 FCB $8C
DMSG12 LDA #12
 FCB $8C
DMSG13 LDA #13
 FCB $8C
DMSG14 LDA #14
 FCB $8C
DMSG15 LDA #15
 FCB $8C
DMSG16 LDA #16
 FCB $8C
DMSG17 LDA #17
 FCB $8C
DMSG18 LDA #18
 FCB $8C
DMSG19 LDA #19
 FCB $8C
DMSG21 LDA #21
 FCB $8C
DMSG22 LDA #22
 FCB $8C
DMSG23 LDA #23
 FCB $8C
DMSG24 LDA #24
 FCB $8C
DMSG26 LDA #26
 FCB $8C
DMSG27 LDA #27
 FCB $8C
DMSG28 LDA #28
 FCB $8C
DMSG29 LDA #29
 FCB $8C
DMSG30 LDA #30
 FCB $8C
DMSG31 LDA #31
 FCB $8C
DMSG32 LDA #32
 FCB $8C
DMSG34 LDA #34
 FCB $8C
DMSG35 LDA #35
 FCB $8C
DMSG36 LDA #36
 FCB $8C
DMSG37 LDA #37
 FCB $8C
DMSG38 LDA #38
 FCB $8C
DMSG39 LDA #39
 FCB $8C
DMSG40 LDA #40
 FCB $8C
DMSG41 LDA #41
 FCB $8C
DMSG42 LDA #42
 FCB $8C
DMSG43 LDA #43
 FCB $8C
DMSG44 LDA #44
 FCB $8C
DMSG45 LDA #45
 FCB $8C
DMSG46 LDA #46
 FCB $8C
DMSG47 LDA #47
 FCB $8C
DMSG48 LDA #48
 FCB $8C
DMSG49 LDA #49
 FCB $8C
DMSG50 LDA #50
 FCB $8C
DMSG51 LDA #51
 FCB $8C
DMSG52 LDA #52
 FCB $8C
DMSG53 LDA #53
 FCB $8C
DMSG54 LDA #54
 FCB $8C
DMSG55 LDA #55
 FCB $8C
DMSG59 LDA #59
 FCB $8C
DMSG60 LDA #60
 FCB $8C
DMSG62 LDA #62
 FCB $8C
DMSG63 LDA #63
 FCB $8C
DMSG65 LDA #65
 FCB $8C
DMSG66 LDA #66
 FCB $8C
DMSG67 LDA #67
 FCB $8C
DMSG68 LDA #68
 FCB $8C
DMSG69 LDA #69
 FCB $8C
DMSG70 LDA #70
 FCB $8C
DMSG71 LDA #71
 FCB $8C
DMSG72 LDA #72
 FCB $8C
DMSG73 LDA #73
 FCB $8C
DMSG74 LDA #74
 FCB $8C
DMSG75 LDA #75
 FCB $8C
DMSG76 LDA #76
 FCB $8C
DMSG77 LDA #77
 FCB $8C
DMSG78 LDA #78
 FCB $8C
DMSG79 LDA #79
 FCB $8C
DMSG80 LDA #80
 FCB $8C
DMSG81 LDA #81
 FCB $8C
DMSG85 LDA #85
 FCB $8C
DMSG86 LDA #86
 FCB $8C
DMSG88 LDA #88
 FCB $8C
DMSG89 LDA #89
 FCB $8C
DMSG90 LDA #90
 FCB $8C
DMSG96 LDA #96
 FCB $8C
DMSG97 LDA #97
 FCB $8C
DMSG98 LDA #98
 FCB $8C
DMSG99 LDA #99
 FCB $8C
DMS101 LDA #101
 FCB $8C
DMS104 LDA #104
DMSGXX LDX #MSG1
A@ DECA
 BEQ C@
B@ TST ,X+
 BNE B@
 BRA A@
C@ JSR DISPLY
 JMP REPLY

*      END GAME ROUTINE

DEAD1 EQU *
 PSHS X
 LDA #26
 STA ROOM
 JSR CLS
 JSR DRAWSC
 PULS X
 JSR DISPLY
 BRA ENDGAM

FINI EQU *
 LDX #MSG27
 JSR DISPLY

ENDGAM EQU *
 LDB POINTS
 CLRA
 TFR D,X
 LDY #MSG25B
 JSR ASCLNO
 JSR SUPRES
 LDX SCORE
 LDY #MSG25A
 JSR ASCLNO
 JSR SUPRES
 LDX #MSG25
 JSR DISPLY
 JSR GETLIN
 LDA KEYBUF
 ANDA #%11011111
 CMPA #'Y
 LBEQ NEWGAM
 JMP BOMBIT

*
* END OF FILE: ADVENT01/ASM
*
