*  FILE: ADVENT03/ASM
*
* DATA VARIABLES AND TABLES
*

*******************************
*
* VERB TABLE.  EACH VERB IS
* LISTED FOLLOWED BY IT'S
* ASSIGNED VERB NUMBER.
*
*******************************

VERBTB EQU *
 FCC 'LOOK',1
 FCC 'L   ',1
 FCC 'EXAM',1
 FCC 'INVE',2
 FCC 'I   ',2
 FCC 'G   ',3
 FCC 'GET ',3
 FCC 'TAKE',3
 FCC 'GRAB',3
 FCC 'PUT ',4
 FCC 'DROP',4
 FCC 'P   ',4
 FCC 'NORT',5
 FCC 'N   ',5
 FCC 'SOUT',6
 FCC 'S   ',6
 FCC 'EAST',7
 FCC 'E   ',7
 FCC 'WEST',8
 FCC 'W   ',8
 FCC 'UP  ',9
 FCC 'U   ',9
 FCC 'DOWN',10
 FCC 'D   ',10
 FCC 'GO  ',11
 FCC 'WALK',11
 FCC 'RUN ',11
 FCC 'ENTE',11
 FCC 'SAVE',13
 FCC 'LOAD',14
 FCC 'HELP',15
 FCC 'SCOR',16
 FCC 'OPEN',17
 FCC 'LIFT',18
 FCC 'READ',19
 FCC 'FEED',20
 FCC 'JUMP',21
 FCC 'ACTI',22
 FCC 'PRES',23
 FCC 'TURN',23
 FCC 'FLIP',23
 FCC 'PUSH',23
 FCC 'TRAD',24
 FCC 'FOLL',25
 FCC 'CUT ',26
 FCC 'CHOP',26
 FCC 'CLEA',26
 FCC 'CLIM',27
 FCC 'UNLO',28
 FCC 'LIST',29
 FCC 'HEAR',29
 FCC 'INFL',30
 FCC 'PUMP',30
 FCC 'DEFL',31
 FCC 'KILL',32
 FCC 'ATTA',32
 FCC 'FIGH',32
 FCC 'LIGH',33
 FCC 'UNLI',34
 FCC 'ROW ',35
 FCC 'PADD',35
 FCC 'BAIL',36
 FCC 'SIT ',37
 FCC 'LAUN',37
 FCC 'RELE',38
 FCC 'REMO',38
 FCC 'GIVE',39
 FCC 'DIG ',40
 FCC 'WEAR',41
 FCC 'QUIT',42
 FCB 0

*******************************
*
* NOUN TABLE.  LISTS ALL NOUNS
* AND THEIR ASSOCIATED NUMBER
*
*******************************

NOUNTB EQU *
 FCC 'NORT',1
 FCC 'SOUT',2
 FCC 'EAST',3
 FCC 'WEST',4
 FCC 'UP  ',5
 FCC 'DOWN',6
 FCC 'INVE',7
 FCC 'FLAS',8
 FCC 'LIGH',8
 FCC 'RUG ',10
 FCC 'SPEC',11
 FCC 'INST',12
 FCC 'MANU',12
 FCC 'JEWE',13
 FCC 'COST',13
 FCC 'TIRE',14
 FCC 'PUMP',14
 FCC 'BUCK',15
 FCC 'TRAP',16
 FCC 'MOUS',16
 FCC 'BOOT',17
 FCC 'MESS',18
 FCC 'PADD',19
 FCC 'SHOV',20
 FCC 'SPAD',20
 FCC 'BOAT',21
 FCC 'KEYS',23
 FCC 'KEY ',23
 FCC 'MACH',24
 FCC 'MICE',26
 FCC 'MICR',27
 FCC 'FILM',27
 FCC 'CROW',28
 FCC 'POTT',29
 FCC 'CHES',30
 FCC 'AIR ',90
 FCC 'JUNG',91
 FCC 'FOLI',91
 FCC 'GROW',91
 FCC 'HILL',92
 FCC 'ENER',93
 FCC 'BUTT',94
 FCC 'SWIT',94
 FCC 'SEAT',95
 FCC 'CELL',97
 FCC 'CLEA',98
 FCC 'FIEL',99
 FCC 'MARS',99
 FCC 'LAB ',100
 FCC 'LABO',100
 FCC 'OCEA',101
 FCC 'WATE',101
 FCC 'NATI',102
 FCC 'IDOL',103
 FCC 'TOMB',104
 FCC 'SHOR',105
 FCC 'BEAC',106
 FCC 'SAND',108
 FCC 'SHAC',109
 FCC 'GRAS',109
 FCC 'JACK',110
 FCC 'TRAD',110
 FCC 'SHED',111
 FCC 'SNAK',112
 FCC 'CREV',114
 FCC 'PATH',115
 FCC 'PASS',116
 FCC 'SPEA',117
 FCC 'PANE',118
 FCC 'LADD',119
 FCC 'DOOR',120
 FCC 'TABL',121
 FCC 'DEVI',122
 FCC 'TELE',122
 FCC 'CABI',124
 FCC 'SIGN',125
 FCC 'DESK',126
 FCC 'STAI',127
 FCC 'STEP',127
 FCC 'ALL ',128
 FCC 'EVER',128
 FCB 0

*******************************
*
* SPECIAL ACTION TABLE. LISTS
* VERB/NOUN COMBO'S THAT HAVE
* SPECIAL PROCESSING ROUTINES.
* FORMAT IS:
*
*  # BYTES       DEXCRIPTION
*  -------   ------------------
*     1      VERB NUMBER
*     1      NOUN NUMBER
*     2      SPECIAL RTN ADDR
*
*******************************

SPCRTN EQU *
 FDB $017E,LOOK01 LOOK DESK
 FDB $0179,LOOK02 LOOK TABLE
 FDB $010A,LOOK03 LOOK RUG
 FDB $0178,LOOK04 LOOK DOOR
 FDB $011E,LOOK05 LOOK CHEST
 FDB $017C,LOOK06 LOOK CABINET
 FDB $0177,LOOK07 LOOK LADDER
 FDB $010C,LOOK08 LOOK MANUAL
 FDB $0160,LOOK09 LOOK SWITCH
 FDB $017A,LOOK10 LOOK DEVICE
 FDB $010B,LOOK11 LOOK SPECS
 FDB $0115,LOOK12 LOOK BOAT
 FDB $0108,LOOK13 LOOK FLASH
 FDB $0173,LOOK14 LOOK PATH
 FDB $011B,LOOK15 LOOK FILM
 FDB $015D,LOOK16 LOOK ENER
 FDB $015C,LOOK17 LOOK HILL
 FDB $0163,LOOK18 LOOK FIELD
 FDB $0164,LOOK19 LOOK LAB
 FDB $016D,LOOK20 LOOK SHACK
 FDB $016F,LOOK21 LOOK SHED
 FDB $015A,DMSG12 LOOK AIR
 FDB $017D,VREAD  LOOK SIGN
 FDB $0307,VINVE TAKE INVENTORY
 FDB $030A,GET01 GET RUG
 FDB $037E,GET02 GET DESK
 FDB $0379,GET02 GET TABLE
 FDB $030B,GET03 GET SPECS
 FDB $030C,GET03 GET MANUAL
 FDB $031A,GET04 GET MICE
 FDB $0315,GET05 GET BOAT
 FDB $0313,GET06 GET PADDLES
 FDB $031E,GET07 GET CHEST
 FDB $0308,GET08 GET FLASH
 FDB $035A,DMSG26 GET AIR
 FDB $041A,PUT01 PUT MICE
 FDB $041E,PUT02 PUT CHEST
 FDB $0408,PUT03 PUT FLASH
 FDB $040D,PUT04 PUT JEWELS
 FDB $045A,DMSG26 PUT AIR
 FDB $0B7F,GO01  GO STAIRS
 FDB $0B77,GO02  GO LADDER
 FDB $0B61,GO02  GO CELLAR
 FDB $0B74,GO03  GO PASSAGE
 FDB $0B7A,GO04  GO DEVICE
 FDB $0B5F,GO04  GO SEAT
 FDB $0B63,GO05  GO FIELD
 FDB $0B73,GO06  GO PATH
 FDB $0B64,GO07  GO LAB
 FDB $0B6F,GO08  GO SHED
 FDB $0B6D,GO09  GO SHACK
 FDB $0B5C,GO10  GO HILL
 FDB $0B5B,GO11  GO JUNGLE
 FDB $0B72,GO12  GO CREVICE
 FDB $0B69,GO13  GO SHORE
 FDB $0B6A,GO13  GO BEACH
 FDB $0B15,GO14  GO BOAT
 FDB $0B62,GO15  GO CLEARING
 FDB $0B78,GO16  GO DOOR
 FDB $2515,GO14  SIT BOAT
 FDB $111E,OPEN01 OPEN CHEST
 FDB $117E,OPEN02 OPEN DESK
 FDB $110A,GET01 GET RUG
 FDB $120A,GET01 LIFT RUG
 FDB $1312,LOOKOB READ MESSAGE
 FDB $131B,LOOK15 READ FILM
 FDB $1368,LOOKOB READ TOMB
 FDB $1973,GO06  FOLLOW PATH
 FDB $1B77,GO02  CLIMB LADDER
 FDB $1B5C,GO10  CLIMB HILL
 FDB $1B7F,GO01  CLIMB STAIRS
 FDB $265A,VDEFL RELEASE AIR
 FDB $2911,VGET WEAR BOOTS
 FDB $290B,GET03 WEAR SPECS
 FDB 0

*******************************
*
* SPECIAL ACTION ON ENTRY TO A
* ROOM TABLE.  FORMAT IS:
*      ROOM#,RTNADDR
*
*******************************

ENTRTB EQU *
 FCB 3,>ENTR03
 FCB 4,>ENTR03
 FCB 6,>ENTR06
 FCB 7,>ENTR06
 FCB 11,>ENTR03
 FCB 12,>ENTR03
 FCB 13,>ENTR03
 FCB 14,>ENTR03
 FCB 15,>ENTR15
 FCB 19,>ENTR19
 FCB 23,>ENTR23
 FCB 24,>ENTR24
 FCB 25,>ENTR24
 FCB 0

*******************************
*
* SPECIAL ACTION ON EXIT FROM
* A ROOM TABLE.
*
*******************************

EXITTB EQU *
 FCB 3,>EXIT03
 FCB 4,>EXIT03
 FCB 6,>EXIT06
 FCB 7,>EXIT06
 FCB 11,>EXIT03
 FCB 12,>EXIT03
 FCB 13,>EXIT03
 FCB 14,>EXIT03
 FCB 19,>EXIT19
 FCB 20,>EXBOAT
 FCB 21,>EXBOAT
 FCB 22,>EXIT22
 FCB 24,>EXIT24
 FCB 25,>EXIT24
 FCB 0

*******************************
*
* SPECIAL ACTION FOR COMMANDS
* GIVEN WHILE IN A ROOM TABLE
*
*******************************

INRMTB EQU *
 FCB 1,>INRM01
 FCB 6,>INRM06
 FCB 7,>INRM06
 FCB 24,>INRM24
 FCB 25,>INRM24
 FCB 0

*******************************
*
* MESSAGE TABLE FOR GENERAL
* LOOK AT OBJECT ROUTINE
*
* FMT: FCB OBJ#
*          MSG# IF CARRYING
*          MSG# IF IN ROOM
*
*******************************

OBJMSG EQU *
 FCB 16,43,43  MOUSETRAP
 FCB 18,41,10  MESSAGE
 FCB 11,40,71  SPECS
 FCB 118,49,49 PANEL
 FCB 117,49,49 SPEAKER
 FCB 17,46,46  BOOTS
 FCB 21,77,77  DEFLATED BOAT
 FCB 93,0,75   INFLATED BOAT
 FCB 104,93,93 TOMBSTONE
 FCB 103,94,94 IDOL
 FCB 29,95,95  POTTERY
 FCB 28,100,100 CROWN
 FCB 0

*******************************
* DEFINE OBJECTS THAT SHOULD
* BE REFERRED TO AS "THEM"
*******************************

THEMTB EQU *
 FCB 11 SPECS
 FCB 17 BOOTS
 FCB 19 PADDLES
 FCB 23 KEYS
 FCB 26 MICE
 FCB 127 STAIRS
 FCB 102 NATIVES
 FCB 0

*******************************
*
* ROOM TABLE.  DEFINES THE
* LAYOUT OF THE ADVENTURE. EACH
* ENTRY HAS THE FOLLOWING
* FORMAT:
*
* # BYTES        DESCRIPTION
* -------   -------------------
*    1      ROOM # TO NORTH
*    1      ROOM # TO SOUTH
*    1      ROOM # TO EAST
*    1      ROOM # TO WEST
*    1      ROOM # UP
*    1      ROOM # DOWN
*   RMOBJ   OBJECTS IN ROOM
*
*******************************

ROOMTB EQU *
*ROOM 1
 FCB 0,0,0,0,0,0
 FCB 126,32,121,120+INV,18+INV
 FCB 127,27+INV,119+INV
 FCB RMOBJ-8[0]
*ROOM 2
 FCB 0,0,0,0,0,1
 FCB 8,30,13,127
 FCB RMOBJ-4[0]
*ROOM 3
 FCB 0,0,0,0,1,0
 FCB 14,15,16+INV,124
 FCB RMOBJ-4[0]
*ROOM 4
 FCB 3,5,0,0,0,0
 FCB 125
 FCB RMOBJ-1[0]
*ROOM 5
 FCB 0,0,0,0,0,0
 FCB 122,116,17
 FCB RMOBJ-3[0]
*ROOM 6
 FCB 0,0,0,0,0,0
 FCB 118,117,100
 FCB RMOBJ-3[0]
*ROOM 7
 FCB 0,0,0,0,0,0
 FCB 118,117,99
 FCB RMOBJ-3[0]
*ROOM 8
 FCB 0,0,0,9,0,0
 FCB 122
 FCB RMOBJ-1[0]
*ROOM 9
 FCB 0,0,8,0,0,0
 FCB 115
 FCB RMOBJ-1[0]
*ROOM 10
 FCB 9,0,0,0,0,0
 FCB 114
 FCB RMOBJ-1[0]
*ROOM 11
 FCB 0,12,12,12,0,0
 FCB 113
 FCB RMOBJ-1[0]
*ROOM 12
 FCB 11,12,13,12,0,0
 FCB RMOBJ[0]
*ROOM 13
 FCB 13,14,13,12,0,0
 FCB RMOBJ[0]
*ROOM 14
 FCB 13,0,0,0,0,0
 FCB 112,19
 FCB RMOBJ-2[0]
*ROOM 15
 FCB 0,0,0,0,16,8
 FCB RMOBJ[0]
*ROOM 16
 FCB 15,0,0,0,0,0
 FCB 111
 FCB RMOBJ-1[0]
*ROOM 17
 FCB 0,0,0,16,0,0
 FCB 20,21,26
 FCB RMOBJ-3[0]
*ROOM 18
 FCB 0,0,0,0,16,0
 FCB 109,108,101
 FCB RMOBJ-3[0]
*ROOM 19
 FCB 0,0,18,0,0,0
 FCB 110,23,24
 FCB RMOBJ-3[0]
*ROOM 20
 FCB 0,0,0,0,0,0
 FCB 101,106
 FCB RMOBJ-2[0]
*ROOM 21
 FCB 0,0,0,0,0,0
 FCB 101,105
 FCB RMOBJ-2[0]
*ROOM 22
 FCB 0,0,0,0,0,0
 FCB 98,102,101,93
 FCB RMOBJ-4[0]
*ROOM 23
 FCB 0,0,22,0,0,0
 FCB 104,103,29+INV,28+INV
 FCB RMOBJ-4[0]
*ROOM 24
 FCB 0,0,0,0,0,0
 FCB 101
 FCB RMOBJ-1[0]
*ROOM 25
 FCB 0,0,0,0,0,0
 FCB 101
 FCB RMOBJ-1[0]
*ROOM 26
 FCB 0,0,0,0,0,0
 FCB RMOBJ[0]

*******************************
* TREASURE POINT TABLE
*
* FORMAT: FCB TREASURE,POINTS
*******************************

PNTTAB EQU *
 FCB 28,1
 FCB 0

*******************************
*
* GRAPHIC SCREEN INDICATOR
* TABLE (BY ROOM)
*
*******************************

SCRIND EQU *
*ROOM 1
 FCB 1,11,5,6,31,1,2,4,93,NOVLY-8[0]
*ROOM 2
 FCB 2,11,13,14,12,NOVLY-4[0]
*ROOM 3
 FCB 4,30,27,28,23,24,25,NOVLY-6[0]
*ROOM 4
 FCB 4,59,60,63,99,NOVLY-4[0]
*ROOM 5
 FCB 1,11,5,6,31,41,42,32,45,NOVLY-8[0]
*ROOM 6
 FCB 2,49,47,48,50,109,110,111,112,NOVLY-8[0]
*ROOM 7
 FCB 2,49,51,52,53,113,114,115,116,NOVLY-8[0]
*ROOM 8
 FCB 1,33,67,34,36,NOVLY-4[0]
*ROOM 9
 FCB 1,36,33,55,75,73,NOVLY-5[0]
*ROOM 10
 FCB 1,33,75,74,69,70,71,72,NOVLY-7[0]
*ROOM 11
 FCB 4,59,60,63,64,65,66,61,NOVLY-7[0]
*ROOM 12
 FCB 4,59,60,63,64,65,61,62,NOVLY-7[0]
*ROOM 13
 FCB 4,59,60,63,64,65,61,62,NOVLY-7[0]
*ROOM 14
 FCB 4,64,65,63,56,57,58,NOVLY-6[0]
*ROOM 15
 FCB 1,36,34,68,NOVLY-3[0]
*ROOM 16
 FCB 1,36,33,54,55,80,79,78,77,NOVLY-8[0]
*ROOM 17
 FCB 5,33,83,NOVLY-2[0]
*ROOM 18
 FCB 1,36,81,82,84,85,86,87,NOVLY-7[0]
*ROOM 19
 FCB 6,43,91,96,NOVLY-3[0]
*ROOM 20
 FCB 1,35,36,37,117,NOVLY-4[0]
*ROOM 21
 FCB 1,35,36,37,38,39,NOVLY-5[0]
*ROOM 22
 FCB 1,36,81,82,NOVLY-3[0]
*ROOM 23
 FCB 1,33,36,67,104,107,108,NOVLY-6[0]
*ROOM 24
 FCB 1,36,35,NOVLY-2[0]
*ROOM 25
 FCB 1,36,35,NOVLY-2[0]
*ROOM 26
 FCB 1,33,36,67,107,108,NOVLY-5[0]

*******************************
*
* ANTIMATION ROUTINES BY ROOM
*
* FORMAT: ROOM #,RTN VECTOR
*
*******************************

ANTTAB EQU *
 FCB 1,>MOVCLK
 FCB 5,>MOVLSR
 FCB 6,>MOVLIT
 FCB 7,>MOVLIT
 FCB 8,>MOVCLO
 FCB 9,>MOVCLO
 FCB 14,>MOVSNK
 FCB 15,>MOVCLO
 FCB 16,>MOVCLO
 FCB 18,>MOVCLO
 FCB 20,>MOVCLO
 FCB 21,>MOVCLO
 FCB 22,>MOVCLO
 FCB 23,>MOVCLO
 FCB 24,>MOVCLO
 FCB 25,>MOVCLO
 FCB 26,>MOVCLO
 FCB 0

*******************************
*
* IF OBJECT DROPPED IN ROOM
* PUT IT IN ANOTHER ROOM TABLE
*
* FORMAT: CURR ROOM,NEW ROOM
*
*******************************

PUTTAB EQU *
 FCB 0

*******************************
*
* MOVABLE OBJ TABLE
*
* OBJECT #,ROOM #,OVERLAY #
*
*******************************

MOVOBJ EQU *
*      JEWELLED CROWN
 FCB 28,23,105
*      MAYAN POTTERY
 FCB 29,23,106
*      TRADER JACK
 FCB 110,19,90
*      SIGN
 FCB 125,19,92
*      SNAKE
 FCB 112,14,94
*      RUG
 FCB 10,1,118
 FCB 10,5,118
 FCB 10,8,118
 FCB 10,9,118
 FCB 10,16,118
 FCB 10,17,118
 FCB 10,18,118
 FCB 10,19,118
*      MOUSETRAP
 FCB 16,3,119
*      BOOTS
 FCB 17,5,95
 FCB 17,8,95
 FCB 17,16,95
 FCB 17,17,95
 FCB 17,18,95
*      MICE
 FCB 26,17,100
*      NATIVES
 FCB 102,22,101
*      INFLATED BOAT
 FCB 93,18,102
 FCB 93,22,102
*      PADDLES
 FCB 19,14,103
*      SHOVEL
 FCB 20,17,88
*      DEFLATED BOAT
 FCB 21,16,89
 FCB 21,17,89
 FCB 21,18,89
 FCB 21,22,89
*      KEYS
 FCB 23,19,97
*      MACHETE
 FCB 24,19,98
*      CUT PATH
 FCB 107,9,76
*      OCEAN
 FCB 101,24,37
 FCB 101,25,37
*      DEVICE
 FCB 122,8,32
*      RUG OVER TRAP DOOR
 FCB 32,1,7
*      MESSAGE
 FCB 18,1,10
*      TRAP DOOR
 FCB 120,1,3
*      LADDER
 FCB 119,1,8
*      FLASHLIGHT
 FCB 8,2,17
 FCB 9,2,17
 FCB 8,8,17
 FCB 9,8,17
 FCB 8,16,17
 FCB 9,16,17
 FCB 8,18,17
 FCB 9,18,17
*      CHEST
 FCB 30,2,15
 FCB 31,2,18
 FCB 31,8,18
 FCB 31,18,18
 FCB 31,19,18
*      JEWELRY
 FCB 13,2,16
*      SPECS
 FCB 11,2,19
 FCB 11,3,19
 FCB 11,5,19
 FCB 11,8,19
 FCB 11,16,19
 FCB 11,17,19
 FCB 11,18,19
 FCB 11,22,19
*      MANUAL
 FCB 12,2,20
 FCB 12,3,20
 FCB 12,5,20
 FCB 12,8,20
 FCB 12,16,20
 FCB 12,17,20
 FCB 12,18,20
 FCB 12,22,20
*      TIRE PUMP
 FCB 14,3,21
 FCB 14,16,21
 FCB 14,18,21
*      BUCKET
 FCB 15,3,22
 FCB 15,8,22
 FCB 15,16,22
 FCB 15,17,22
 FCB 15,18,22
 FCB 15,22,22
*      CABINET
 FCB 124,3,29
 FCB 123,3,26
*      DESK
 FCB 94,1,9
 FCB 0

*******************************
*
* GRAPHIC SCREEN PNTR TABLE
*
*******************************

SCRTAB EQU *
 FDB SCRBLU,SCRBLK,SCRWHT
 FDB SCRRED,SCRSHD,SCRSHA

*******************************
*
* GRAPHIC OBJECT PNTR TABLE
*
* FORMAT: SCREEN ROW  - XX
*         SCREEN COL  - XX
*         LINE LEN    - XX
*         DATA        - XX..XX
*         TERM BY $FF
*
*******************************

SCROBJ EQU *
 FDB OVTAB1,OVDSK1,OVDOR1
 FDB OVSTA1,OVSTD1,OVSTD2
 FDB OVRUG1,OVDOR2,OVDSK2
 FDB OVMSG1,OVFLR1,OVSTA2
 FDB OVATC1,OVATC2,OVCHT1
 FDB OVJEW1,OVLIT1,OVCHT2
 FDB OVSPC1,OVMAN1,OVPMP1
 FDB OVBKT1,OVBAS1,OVBAS2
 FDB OVBAS3,OVBAS4,OVBAS5
 FDB OVBAS6,OVBAS7,OVBAS8
 FDB OVSTD3,OVDEV1,OVFLD1
 FDB OVHIL1,OVWAT1,OVCLO1
 FDB OVBOT1,OVISL1,OVTRE1
 FDB OVBOT2,OVLAB1,OVLAB2
 FDB OVBCH3,OVLAB4,OVLAB5
 FDB OVLAB6,OVDVC1,OVDVC2
 FDB OVDVC3,OVDVC4,OVDVC5
 FDB OVDVC6,OVDVC7,OVHIL3
 FDB OVHIL2,OVCHA1,OVCHA2
 FDB OVCHA3,OVPAS1,OVPAS2
 FDB OVPAS3,OVPAS4,OVPAS5
 FDB OVPAS6,OVPAS7,OVPAS8
 FDB OVFLD2,OVSID1,OVJUN1
 FDB OVJUN2,OVJUN3,OVJUN4
 FDB OVJUN5,OVJUN6,OVJUN7
 FDB OVJUN8,OVSHD1,OVSHD2
 FDB OVSHD3,OVSHD4,OVBCH1
 FDB OVBCH2,OVSHD5,OVSHA1
 FDB OVSHA3,OVSHA4,OVSHA5
 FDB OVSVL1,OVBOT3,OVSHA6
 FDB OVSHA2,OVSHAA,OVCLK1
 FDB OVSNK1,OVBTS1,OVSHA7
 FDB OVSHA8,OVSHA9,OVPAS9
 FDB OVMIC1,OVNAT1,OVBOT4
 FDB OVOAR1,OVIDL1,OVCRN1
 FDB OVPOT1,OVTMB1,OVTMB2
 FDB OVDVC8,OVDVC9,OVDVCA
 FDB OVDVCB,OVDVCC,OVDVCD
 FDB OVDVCE,OVDVCF,OVBCH4
 FDB OVRUG2,OVTRP1

GENHLP EQU *
 FCB 13,'T,'r,'y+$80
 FCC 'examinin','g+$80
 FCC 'things.',0

 FCB 13,'N,'o+$80
 FCC 'HEL','P+$80
 FCC 'available.',0

 FCB 13,'U,'s,'e+$80
 FCC 'SAV','E+$80
 FCC 'often.',0

 FCB 13,'I,'','m+$80
 FCC 'stumpe','d+$80
 FCC 'too!',0

*******************************
*
* DIRECTION DESCRIPTIONS TABLE
*
*******************************

DIRECT EQU *
 FCC 'North',',+$80,0
 FCC 'South',',+$80,0
 FCC 'East',',+$80,0
 FCC 'West',',+$80,0
 FCC 'Up',',+$80,0
 FCC 'Down',',+$80,0

*******************************
*
* OBJECT DESCRIPTIONS TABLE
*
*******************************

OBJTAB EQU *

 FCB 8,C.AN
 FCC 'unli','t+$80
 FCC 'flashlight',0

 FCB 9,'a+$80
 FCC 'li','t+$80
 FCC 'flashlight',0

 FCB 10,C.AN
 FCC 'orienta','l+$80
 FCC 'rug',0

 FCB 11,'a+$80
 FCC 'pai','r+$80,'o,'f+$80
 FCC 'spectacles',0

 FCB 12,C.AN
 FCC 'instructio','n+$80
 FCC 'manual',0

 FCB 13,'a+$80
 FCC 'bo','x+$80,'o,'f+$80
 FCC 'costum','e+$80
 FCC 'jewelry',0

 FCB 14,'a+$80
 FCC 'tir','e+$80
 FCC 'pump',0

 FCB 15,'a+$80
 FCC 'bucket',0

 FCB 16,'a+$80
 FCC 'mous','e+$80
 FCC 'trap',0

 FCB 17,'a+$80
 FCC 'pai','r+$80,'o,'f+$80
 FCC 'hikin','g+$80
 FCC 'boots',0

 FCB 18,'a+$80
 FCC 'handwritte','n+$80
 FCC 'message',0

 FCB 19
 FCC 'ancien','t+$80
 FCC 'cano','e+$80
 FCC 'paddles',0

 FCB 20,'a+$80
 FCC 'shovel',0

 FCB 21,'a+$80
 FCC 'deflate','d+$80
 FCC 'rubbe','r+$80
 FCC 'boat',0

 FCB 23
 FCC 'som','e+$80
 FCC 'key','s+$80,C.ONA
 FCC 'chain',0

 FCB 24,'a+$80
 FCC 'machete',0

 FCB 26
 FCC 'mice',0

 FCB 27
 FCC 'microfilm',0

 FCB 28
 FCC .*Montezuma'.,'s+$80
 FCC 'jewelle','d+$80
 FCC 'crown*',0

 FCB 29,C.AN
 FCC 'ancien','t+$80
 FCC 'Maya','n+$80
 FCC 'pottery',0

 FCB 30,C.AN
 FCC 'ol','d+$80
 FCC 'woode','n+$80
 FCC 'chest',0

 FCB 31,$FF,30,0

 FCB 32,$FF,10,0

 FCB 93,'a+$80
 FCC 'bi','g+$80
 FCC 'rubbe','r+$80
 FCC 'boat',0

 FCB 94,'a+$80
 FCC 'rol','l+$80
 FCC 'to','p+$80
 FCC 'desk',0

 FCB 98,'a+$80
 FCC 'clearin','g+$80
 FCB 'i,'n+$80,C.THE
 FCC 'jungle',0

 FCB 99,'a+$80
 FCC 'marsh','y+$80
 FCC 'field',0

 FCB 100,C.THE
 FCC .Professor'.,'s+$80
 FCC 'laboratory',0

 FCB 101,'a+$80
 FCC 'lo','t+$80,'o,'f+$80
 FCC 'ocean',0

 FCB 102
 FCC 'unfriendl','y+$80
 FCC 'natives',0

 FCB 103,'a+$80
 FCC 'paga','n+$80
 FCC 'idol',0

 FCB 104,'a+$80
 FCC 'tombstone',0

 FCB 105,C.THE
 FCC 'sand','y+$80
 FCC 'shor','e+$80,'o,'f+$80
 FCC 'Calixto',0

 FCB 106,'a+$80
 FCC 'war','m+$80
 FCC 'tropica','l+$80
 FCC 'beach',0

 FCB 107,'a+$80
 FCC 'freshl','y+$80
 FCC 'cu','t+$80
 FCC 'path',0

 FCB 108
 FCC 'sand',0

 FCB 109,'a+$80
 FCC 'gras','s+$80
 FCC 'shack',0

 FCB 110
 FCC 'Trade','r+$80
 FCC 'Jac','k+$80,C.THE
 FCC 'beachcomber',0

 FCB 111,'a+$80
 FCC 'storag','e+$80
 FCC 'shed',0

 FCB 112,'a+$80
 FCC 'hungr','y+$80
 FCC 'lookin','g+$80
 FCC 'snake',0

 FCB 113,'a+$80
 FCC 'narro','w+$80
 FCC 'crevic','e+$80
 FCB 'i,'n+$80,C.THE
 FCC 'wall',0

 FCB 114,'a+$80
 FCC 'crevic','e+$80
 FCC 'betwee','n+$80
 FCC 'tw','o+$80
 FCC 'stones',0

 FCB 115,'a+$80
 FCC 'pat','h+$80
 FCC 'barel','y+$80
 FCC 'visibl','e+$80
 FCC 'throug','h+$80
 FCC 'dens','e+$80
 FCC 'jungl','e+$80
 FCC 'foliage',0

 FCB 116,'a+$80
 FCC 'passageway',0

 FCB 117,'a+$80
 FCC 'smal','l+$80
 FCC 'speaker',0

 FCB 118,'a+$80
 FCC 'pane','l+$80,'o,'f+$80
 FCC 'pulsin','g+$80
 FCC 'lights',0

 FCB 119,'a+$80
 FCC 'ladde','r+$80
 FCC 'leadin','g+$80
 FCB 't,'o+$80,'a+$80
 FCC 'cellar',0

 FCB 120,'a+$80
 FCC 'tra','p+$80
 FCC 'doo','r+$80
 FCB 'i,'n+$80,C.THE
 FCC 'floor',0

 FCB 121,C.AN
 FCC 'antiqu','e+$80
 FCC 'table',0

 FCB 122,C.AN
 FCC 'unusua','l+$80
 FCC 'lookin','g+$80
 FCC 'device',0

 FCB 123,'a+$80
 FCC 'storag','e+$80
 FCC 'cabine','t+$80
 FCC 'wit','h+$80,'a+$80
 FCC 'secre','t+$80
 FCC 'passag','e+$80
 FCC 'behin','d+$80
 FCC 'it',0

 FCB 124,'a+$80
 FCC 'storag','e+$80
 FCC 'cabinet',0

 FCB 125,'a+$80
 FCC 'sign',0

 FCB 126,$FF,94,0

 FCB 127,'a+$80
 FCC 'fligh','t+$80,'o,'f+$80
 FCC 'stairs',0

*******************************
*
* ROOM DESCRIPTIONS TABLE
*
*******************************

DESCTB EQU *
*ROOM 1
 FCB C.IM,'i,'n+$80
 FCC 'Professo','r+$80
 FCC .Lagarto'.,'s+$80
 FCC 'comfortabl','e+$80
 FCC 'study.',0
*ROOM 2
 FCB C.IM,C.INA
 FCC 'diml','y+$80
 FCC 'li','t+$80
 FCC 'attic.',0
*ROOM 3
 FCB C.IM,C.INA
 FCC 'must','y+$80
 FCC 'storag','e+$80
 FCC 'cellar.',0
*ROOM 4
 FCB C.IM,C.INA
 FCC 'lon','g+$80
 FCC 'narro','w+$80
 FCC 'passageway.',0
*ROOM 5
 FCB C.IM,'i,'n+$80,C.THE
 FCC .Professor'.,'s+$80
 FCC 'secre','t+$80
 FCC 'laborator','y+$80
 FCC 'fille','d+$80
 FCC 'wit','h+$80
 FCC 'comple','x+$80
 FCC 'machiner','y+$80,C.AND
 FCC 'tes','t+$80
 FCC 'equipment.',0
*ROOM 6
 FCB C.IM
 FCC 'seate','d+$80
 FCC 'insid','e+$80,'a,'n+$80
 FCC 'unusua','l+$80
 FCC 'device.',0
*ROOM 7
 FCB $FF,6,0
*ROOM 8
 FCB C.IM,C.INA
 FCC 'marsh','y+$80
 FCC 'fiel','d+$80,C.AT,C.THE
 FCC 'bas','e+$80
 FCB 'o,'f+$80,'a+$80
 FCC 'stee','p+$80
 FCC 'rock','y+$80
 FCC 'hill.',0
*ROOM 9
 FCB C.IM,C.INA
 FCC 'tropica','l+$80
 FCC 'jungle.',0
*ROOM 10
 FCB C.IM,C.AT,C.THE
 FCC 'remain','s+$80
 FCB 'o,'f+$80,C.AN
 FCC 'ancien','t+$80
 FCC 'Maya','n+$80
 FCC 'pyramid.',0
*ROOM 11
 FCB C.IM,C.INA
 FCC 'Maya','n+$80
 FCC 'pyramid','.+$80
 FCC 'Strang','e+$80
 FCC 'design','s+$80
 FCC 'cove','r+$80,C.THE
 FCC 'walls.',0
*ROOM 12
 FCB $FF,11,0
*ROOM 13
 FCB $FF,11,0
*ROOM 14
 FCB C.IM,C.INA
 FCC 'larg','e+$80
 FCC 'roo','m+$80
 FCC 'decorate','d+$80
 FCC 'wit','h+$80
 FCC 'Maya','n+$80
 FCC 'artwork.',0
*ROOM 15
 FCB C.IM,'o,'n+$80,C.THE
 FCC 'sid','e+$80
 FCB 'o,'f+$80,'a+$80
 FCC 'stee','p+$80
 FCC 'rock','y+$80
 FCC 'hill.',0
*ROOM 16
 FCB C.IM,C.ONA
 FCC 'hilltop','.+$80
 FCB 'A+$80
 FCC 'pat','h+$80
 FCC 'slope','s+$80
 FCB 't,'o+$80,'a+$80
 FCC 'beac','h+$80
 FCC 'below.',0
*ROOM 17
 FCB C.IM,C.INA,8,'n+$80
 FCC 'ol','d+$80
 FCC 'storag','e+$80
 FCC 'shed.',0
*ROOM 18
 FCB C.IM,C.ONA
 FCC 'war','m+$80
 FCC 'tropica','l+$80
 FCC 'beach.',0
*ROOM 19
 FCB C.IM,C.INA
 FCC 'smal','l+$80
 FCC 'gras','s+$80
 FCC 'shack.',0
*ROOM 20
 FCB C.IM,C.INA
 FCC 'rubbe','r+$80
 FCC 'boat.',0
*ROOM 21
 FCB $FF,20,0
*ROOM 22
 FCB C.IM,'o,'n+$80,C.THE
 FCC 'shor','e+$80,'o,'f+$80
 FCC 'Calixto.',0
*ROOM 23
 FCB C.IM,C.INA
 FCC 'nativ','e+$80
 FCC 'ceremonia','l+$80
 FCC 'area.',0
*ROOM 24
 FCB $FF,20,0
*ROOM 25
 FCB $FF,20,0

*******************************
*
* COMPRESSED PHRASE TABLE
*
*******************************

TXTTAB EQU *
 FCC 'th','e+$80,0
 FCC 'yo','u+$80,0
 FCC 'ar','e+$80,0
 FCC 'se','e+$80,0
 FCC 'can','','t+$80,0
 FCC 'don','','t+$80,0
 FCC 'Yo','u+$80,0
 FCB 'I,'','m+$80,0
 FCB 'i,'n+$80,'a+$80,0
 FCB 'o,'n+$80,'a+$80,0
 FCB 'i,'s+$80,'a+$80,0
 FCC .It'.,'s+$80,0
 FCC 'Th','e+$80,0
 FCB 'i,'s+$80,0
 FCC 'an','d+$80,0
 FCB 'a,'n+$80,0
 FCB 'a,'t+$80,0

*******************************
*
* VERB ROUTINE JUMP VECTORS
*
*******************************

RTNTAB EQU *
 FDB VLOOK,VINVE,VGET,VPUT
 FDB VNORTH,VSOUTH,VEAST,VWEST
 FDB VUP,VDOWN,VGO,VGO
 FDB VSAVE,VLOAD,VHELP,VSCORE
 FDB VOPEN,BADINP,VREAD
 FDB VFEED,DMS104,VACTIV
 FDB VPRESS,VTRADE,BADINP
 FDB VCUT,BADINP,VUNLOK
 FDB DMSG70,VINFL,VDEFL,VKILL
 FDB VLIGHT,VUNLIT,VROW,VBAIL
 FDB BADINP,VPUT,VGIVE,VDIG
 FDB BADINP,ENDGAM

*******************************
*
* NON ARRAY VARIABLES
*
*******************************

COMMA FCB ',+$80,0

*
* END OF FILE: ADVENT03/ASM
*
